地址:https://leetcode-cn.com/problems/house-robber-iii/
198.打家劫舍地址: https://leetcode-cn.com/problems/house-robber/
思路:树状dp
对于根节点为 rt 的子树,dp[rt][k]为其根节点取和不取(k=0/1)时子树的最大价值,ld,rd分别为其左右节点,那么
dp[rt][0]=max(dp[ld][0],dp[ld][1])+max(dp[rd][0],dp[rd][1]);
dp[rt][1]=dp[ld][0]+dp[rd][0]+root->val;
由于不知道其节点的下标以及dp只与其左右节点相关,因此可以直接DFS返回dp[rt][0,1]给父节点即可
Code:
class Solution {
public:
int rob(TreeNode* root) {
pair<int,int> res=DFS(root);
return max(res.first,res.second);
}
pair<int,int> DFS(TreeNode* root){
if(root==NULL) return {0,0};
pair<int,int> rt,dl,dr;
dl=DFS(root->left);
dr=DFS(root->right);
rt.first=max(dl.first,dl.second)+max(dr.first,dr.second);
rt.second=dl.first+dr.first+root->val;
return rt;
}
};